﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Labs.Utility;
using OpenTK;
using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;

namespace Labs.ACW
{
    class Box : StaticObject
    {
        public Vector3 position;
        private bool isEmitter;
        private ModelUtility boxModelUtil;
        private float rotation, scale;
        public Matrix4 mBoxModel;

        public Box(Vector3 inPos, bool inEmit, ref ModelUtility mBoxUtil, float inScale, float inRotation, ref Matrix4 inMModel)
        {
            position = inPos;
            isEmitter = inEmit;
            boxModelUtil = mBoxUtil;
            scale = inScale;
            rotation = inRotation;
            mBoxModel = inMModel;
        }

        public virtual void OnLoad(EventArgs e, ref int[] mVAO_IDs, ref int[] mVBO_IDs)
        {
            //Position
            //Size

            mBoxModel = Matrix4.CreateTranslation(position) * Matrix4.CreateScale(scale);
        }

        public virtual void OnUpdateFrame(FrameEventArgs e, Vector3 ballPosition, ref Vector3 ballVelocity, float ballRadius, Vector3 oldPos)
        {
        }

        public virtual void OnRenderFrame(FrameEventArgs e, ref int[] mVAO_IDs, ref Matrix4 mGroundModel, ref int uModel, ref ShaderUtility mShader)
        {
            Matrix4 mThing = Matrix4.CreateScale(5) * Matrix4.CreateTranslation(position);
            uModel = GL.GetUniformLocation(mShader.ShaderProgramID, "uModel");
            GL.UniformMatrix4(uModel, true, ref mThing);

            GL.BindVertexArray(mVAO_IDs[3]);
            GL.DrawElements(PrimitiveType.Triangles, boxModelUtil.Indices.Length, DrawElementsType.UnsignedInt, 0);
        }

    }
}

//NOTES FOR THIS OBJECT